# coding: utf-8

"""
    Collibra Import API

    <p>The Import API is an efficient way to load large volumes of data into the Collibra Data Governance Center. The API can automatically differentiate between creating and updating data.</p>  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ResourceTypeSummary(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'resource_type': 'str',
        'counters': 'ImportCounters',
        'subcategories': 'list[SubcategorySummary]'
    }

    attribute_map = {
        'resource_type': 'resourceType',
        'counters': 'counters',
        'subcategories': 'subcategories'
    }

    def __init__(self, resource_type=None, counters=None, subcategories=None):  # noqa: E501
        """ResourceTypeSummary - a model defined in Swagger"""  # noqa: E501
        self._resource_type = None
        self._counters = None
        self._subcategories = None
        self.discriminator = None
        if resource_type is not None:
            self.resource_type = resource_type
        if counters is not None:
            self.counters = counters
        if subcategories is not None:
            self.subcategories = subcategories

    @property
    def resource_type(self):
        """Gets the resource_type of this ResourceTypeSummary.  # noqa: E501

        Import resource type.  # noqa: E501

        :return: The resource_type of this ResourceTypeSummary.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this ResourceTypeSummary.

        Import resource type.  # noqa: E501

        :param resource_type: The resource_type of this ResourceTypeSummary.  # noqa: E501
        :type: str
        """
        allowed_values = ["COMMUNITY", "DOMAIN", "ASSET", "ATTRIBUTE", "RELATION", "COMPLEX_RELATION", "MAPPING", "RESPONSIBILITY"]  # noqa: E501
        if resource_type not in allowed_values:
            raise ValueError(
                "Invalid value for `resource_type` ({0}), must be one of {1}"  # noqa: E501
                .format(resource_type, allowed_values)
            )

        self._resource_type = resource_type

    @property
    def counters(self):
        """Gets the counters of this ResourceTypeSummary.  # noqa: E501


        :return: The counters of this ResourceTypeSummary.  # noqa: E501
        :rtype: ImportCounters
        """
        return self._counters

    @counters.setter
    def counters(self, counters):
        """Sets the counters of this ResourceTypeSummary.


        :param counters: The counters of this ResourceTypeSummary.  # noqa: E501
        :type: ImportCounters
        """

        self._counters = counters

    @property
    def subcategories(self):
        """Gets the subcategories of this ResourceTypeSummary.  # noqa: E501

        A detailed summary of the number of resources that have been affected by the import job. This can be empty for some resource types, f.e. <code>Mapping</code>.  # noqa: E501

        :return: The subcategories of this ResourceTypeSummary.  # noqa: E501
        :rtype: list[SubcategorySummary]
        """
        return self._subcategories

    @subcategories.setter
    def subcategories(self, subcategories):
        """Sets the subcategories of this ResourceTypeSummary.

        A detailed summary of the number of resources that have been affected by the import job. This can be empty for some resource types, f.e. <code>Mapping</code>.  # noqa: E501

        :param subcategories: The subcategories of this ResourceTypeSummary.  # noqa: E501
        :type: list[SubcategorySummary]
        """

        self._subcategories = subcategories

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceTypeSummary, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceTypeSummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
