# coding: utf-8

"""
    Collibra Import API

    <p>The Import API is an efficient way to load large volumes of data into the Collibra Data Governance Center. The API can automatically differentiate between creating and updating data.</p>  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SynchronizationBatchJsonInJobRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'send_notification': 'bool',
        'batch_size': 'int',
        'simulation': 'bool',
        'save_result': 'bool',
        'synchronization_id': 'str',
        'file_id': 'str',
        'file': 'str',
        'file_name': 'str',
        'delete_file': 'bool',
        'continue_on_error': 'bool',
        'relations_action': 'str'
    }

    attribute_map = {
        'send_notification': 'sendNotification',
        'batch_size': 'batchSize',
        'simulation': 'simulation',
        'save_result': 'saveResult',
        'synchronization_id': 'synchronizationId',
        'file_id': 'fileId',
        'file': 'file',
        'file_name': 'fileName',
        'delete_file': 'deleteFile',
        'continue_on_error': 'continueOnError',
        'relations_action': 'relationsAction'
    }

    def __init__(self, send_notification=None, batch_size=1000, simulation=None, save_result=None, synchronization_id=None, file_id=None, file=None, file_name=None, delete_file=None, continue_on_error=None, relations_action=None):  # noqa: E501
        """SynchronizationBatchJsonInJobRequest - a model defined in Swagger"""  # noqa: E501
        self._send_notification = None
        self._batch_size = None
        self._simulation = None
        self._save_result = None
        self._synchronization_id = None
        self._file_id = None
        self._file = None
        self._file_name = None
        self._delete_file = None
        self._continue_on_error = None
        self._relations_action = None
        self.discriminator = None
        if send_notification is not None:
            self.send_notification = send_notification
        if batch_size is not None:
            self.batch_size = batch_size
        if simulation is not None:
            self.simulation = simulation
        if save_result is not None:
            self.save_result = save_result
        self.synchronization_id = synchronization_id
        if file_id is not None:
            self.file_id = file_id
        if file is not None:
            self.file = file
        if file_name is not None:
            self.file_name = file_name
        if delete_file is not None:
            self.delete_file = delete_file
        if continue_on_error is not None:
            self.continue_on_error = continue_on_error
        if relations_action is not None:
            self.relations_action = relations_action

    @property
    def send_notification(self):
        """Gets the send_notification of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        Whether job status notification should be sent. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :return: The send_notification of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._send_notification

    @send_notification.setter
    def send_notification(self, send_notification):
        """Sets the send_notification of this SynchronizationBatchJsonInJobRequest.

        Whether job status notification should be sent. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :param send_notification: The send_notification of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: bool
        """

        self._send_notification = send_notification

    @property
    def batch_size(self):
        """Gets the batch_size of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        <i>The batchSize parameter is now deprecated and is ignored during command execution.</i>  # noqa: E501

        :return: The batch_size of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: int
        """
        return self._batch_size

    @batch_size.setter
    def batch_size(self, batch_size):
        """Sets the batch_size of this SynchronizationBatchJsonInJobRequest.

        <i>The batchSize parameter is now deprecated and is ignored during command execution.</i>  # noqa: E501

        :param batch_size: The batch_size of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: int
        """

        self._batch_size = batch_size

    @property
    def simulation(self):
        """Gets the simulation of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        Whether the import should be triggered as a simulation. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the result of the import simulation will be available at the end of the job but no change will be applied to the DGC.  # noqa: E501

        :return: The simulation of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._simulation

    @simulation.setter
    def simulation(self, simulation):
        """Sets the simulation of this SynchronizationBatchJsonInJobRequest.

        Whether the import should be triggered as a simulation. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the result of the import simulation will be available at the end of the job but no change will be applied to the DGC.  # noqa: E501

        :param simulation: The simulation of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: bool
        """

        self._simulation = simulation

    @property
    def save_result(self):
        """Gets the save_result of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        Whether the import Result should be persisted or forgotten. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the result of the import simulation will be available at the end of the job but no change will be applied to the DGC.<p><b>DEPRECATED:</b>This parameter is deprecated and will be removed in the future.</b>.  # noqa: E501

        :return: The save_result of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._save_result

    @save_result.setter
    def save_result(self, save_result):
        """Sets the save_result of this SynchronizationBatchJsonInJobRequest.

        Whether the import Result should be persisted or forgotten. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the result of the import simulation will be available at the end of the job but no change will be applied to the DGC.<p><b>DEPRECATED:</b>This parameter is deprecated and will be removed in the future.</b>.  # noqa: E501

        :param save_result: The save_result of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: bool
        """

        self._save_result = save_result

    @property
    def synchronization_id(self):
        """Gets the synchronization_id of this SynchronizationBatchJsonInJobRequest.  # noqa: E501


        :return: The synchronization_id of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._synchronization_id

    @synchronization_id.setter
    def synchronization_id(self, synchronization_id):
        """Sets the synchronization_id of this SynchronizationBatchJsonInJobRequest.


        :param synchronization_id: The synchronization_id of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: str
        """
        if synchronization_id is None:
            raise ValueError("Invalid value for `synchronization_id`, must not be `None`")  # noqa: E501

        self._synchronization_id = synchronization_id

    @property
    def file_id(self):
        """Gets the file_id of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        The <code>id</code> of uploaded file.<p><b>NOTE:</b> if this field is used, <code>file</code> should not be set.  # noqa: E501

        :return: The file_id of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._file_id

    @file_id.setter
    def file_id(self, file_id):
        """Sets the file_id of this SynchronizationBatchJsonInJobRequest.

        The <code>id</code> of uploaded file.<p><b>NOTE:</b> if this field is used, <code>file</code> should not be set.  # noqa: E501

        :param file_id: The file_id of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: str
        """

        self._file_id = file_id

    @property
    def file(self):
        """Gets the file of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        The file to upload. If set, then also <code>fileName</code> should be provided.<p><b>NOTE:</b> if this field is used, <code>fileId</code> should not be set.  # noqa: E501

        :return: The file of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._file

    @file.setter
    def file(self, file):
        """Sets the file of this SynchronizationBatchJsonInJobRequest.

        The file to upload. If set, then also <code>fileName</code> should be provided.<p><b>NOTE:</b> if this field is used, <code>fileId</code> should not be set.  # noqa: E501

        :param file: The file of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: str
        """

        self._file = file

    @property
    def file_name(self):
        """Gets the file_name of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        The name of the file to upload. If set, then also <code>file</code> should be provided.<p><b>NOTE:</b> if this field is used, <code>fileId</code> should not be set.  # noqa: E501

        :return: The file_name of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._file_name

    @file_name.setter
    def file_name(self, file_name):
        """Sets the file_name of this SynchronizationBatchJsonInJobRequest.

        The name of the file to upload. If set, then also <code>file</code> should be provided.<p><b>NOTE:</b> if this field is used, <code>fileId</code> should not be set.  # noqa: E501

        :param file_name: The file_name of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: str
        """

        self._file_name = file_name

    @property
    def delete_file(self):
        """Gets the delete_file of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        Whether the file should be deleted after the synchronization job is finished, regardless of the result. <b>The default value</b> is <code>false</code>.<p><b>NOTE:</b> if the file corresponds to an attachment, the attachment will be deleted.  # noqa: E501

        :return: The delete_file of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._delete_file

    @delete_file.setter
    def delete_file(self, delete_file):
        """Sets the delete_file of this SynchronizationBatchJsonInJobRequest.

        Whether the file should be deleted after the synchronization job is finished, regardless of the result. <b>The default value</b> is <code>false</code>.<p><b>NOTE:</b> if the file corresponds to an attachment, the attachment will be deleted.  # noqa: E501

        :param delete_file: The delete_file of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: bool
        """

        self._delete_file = delete_file

    @property
    def continue_on_error(self):
        """Gets the continue_on_error of this SynchronizationBatchJsonInJobRequest.  # noqa: E501

        Whether the import should continue if some of the import commands are invalid or failed to execute. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the valid commands are still committed to the database, which can lead to partial results being stored.  # noqa: E501

        :return: The continue_on_error of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._continue_on_error

    @continue_on_error.setter
    def continue_on_error(self, continue_on_error):
        """Sets the continue_on_error of this SynchronizationBatchJsonInJobRequest.

        Whether the import should continue if some of the import commands are invalid or failed to execute. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the valid commands are still committed to the database, which can lead to partial results being stored.  # noqa: E501

        :param continue_on_error: The continue_on_error of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: bool
        """

        self._continue_on_error = continue_on_error

    @property
    def relations_action(self):
        """Gets the relations_action of this SynchronizationBatchJsonInJobRequest.  # noqa: E501


        :return: The relations_action of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._relations_action

    @relations_action.setter
    def relations_action(self, relations_action):
        """Sets the relations_action of this SynchronizationBatchJsonInJobRequest.


        :param relations_action: The relations_action of this SynchronizationBatchJsonInJobRequest.  # noqa: E501
        :type: str
        """

        self._relations_action = relations_action

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SynchronizationBatchJsonInJobRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SynchronizationBatchJsonInJobRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
